<?php

/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Alter JS to update jquery to latest version
 */

function basedrupal_js_alter(&$javascript) 
{
	/**
	 *  Custom theme variables
	 */
	include 'theme_config.php';
	$vars['theme_custom_settings'] = $theme_custom_settings;

	/**
	 *  Check and alter
	 */
  	if (arg(0) != 'admin' && arg(0) != 'panels' && arg(0) != 'ctools') 
  	{
    	$jquery_file = '//cdn01.its.msstate.edu/e/jquery/'.$theme_custom_settings['assets']['e']['jquery'].'/jquery.min.js';
		$jquery_version = $theme_custom_settings['assets']['e']['jquery'];

	    $migrate_file = '//cdn01.its.msstate.edu/e/jquery-migrate/'.$theme_custom_settings['assets']['e']['jquery-migrate'].'/jquery-migrate.min.js';
	    $migrate_version = $theme_custom_settings['assets']['e']['jquery-migrate'];

	    $javascript['misc/jquery.js']['data'] = $jquery_file;
	    $javascript['misc/jquery.js']['version'] = $jquery_version;
	    $javascript['misc/jquery.js']['type'] = 'external';
	    $javascript['misc/jquery.js']['preprocess'] = FALSE;
	    $javascript['misc/jquery.js']['weight'] = 0;
	    $javascript['misc/jquery.js']['group'] = -101;

	    drupal_add_js($migrate_file);

		if (isset($javascript["$migrate_file"])) 
		{
	    	$javascript["$migrate_file"]['version'] = $migrate_version;
			$javascript["$migrate_file"]['type'] = 'external';
			$javascript["$migrate_file"]['preprocess'] = FALSE;
			$javascript["$migrate_file"]['weight'] = 1;
			$javascript["$migrate_file"]['group'] = -101;
		}
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Preprocess HTML
 */

function basedrupal_preprocess_html(&$vars) 
{
	/**
	 *  Custom theme variables
	 */
	include 'theme_config.php';
	$vars['theme_custom_settings'] = $theme_custom_settings;


	/**
	 *  Add CSS
	 */
	drupal_add_css('//cdn01.its.msstate.edu/e/normalize/'.$theme_custom_settings['assets']['e']['normalize'].'/normalize.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 990));
    drupal_add_css('//cdn01.its.msstate.edu/e/h5bp/'.$theme_custom_settings['assets']['e']['h5bp'].'/h5bp.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 991));
    drupal_add_css('//cdn01.its.msstate.edu/e/bootstrap/'.$theme_custom_settings['assets']['e']['bootstrap'].'/css/bootstrap.min.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 992));
    drupal_add_css('//cdn01.its.msstate.edu/e/slick/'.$theme_custom_settings['assets']['e']['slick'].'/slick.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 993));
    drupal_add_css('//cdn01.its.msstate.edu/e/slick/'.$theme_custom_settings['assets']['e']['slick'].'/slick-theme.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 994));
    
    if ($theme_custom_settings['social'] != 'none')
    	drupal_add_css('//cdn01.its.msstate.edu/i/social-icons/'.$theme_custom_settings['assets']['i']['social-icons'].'/css/social-icons.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 995));
	
	drupal_add_css('//cdn01.its.msstate.edu/i/basedrupal/'.$theme_custom_settings['assets']['i']['base'].'/css/base.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 998));
	
	if ($theme_custom_settings['theme_style'] == 'chevron')
		drupal_add_css('//cdn01.its.msstate.edu/i/basedrupal/'.$theme_custom_settings['assets']['i']['base'].'/css/chevron.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 999));
	
	if ($theme_custom_settings['theme_style'] == 'true-bulldog')
		drupal_add_css('//cdn01.its.msstate.edu/i/basedrupal/'.$theme_custom_settings['assets']['i']['base'].'/css/truebulldog.css', array('type' => 'external', 'group' => CSS_THEME, 'weight' => 999));

	drupal_add_css(drupal_get_path('theme', $theme_custom_settings['theme_name']).'/css/app.css', array('group' => CSS_THEME, 'weight' => 999));


	/**
	 *  Add JS
	 */
	drupal_add_js('//cdn01.its.msstate.edu/i/emergency/'.$theme_custom_settings['assets']['i']['emergency'].'/hazard.js', array('type' => 'external', 'group' => JS_THEME, 'weight' => 990));
    drupal_add_js('//cdn01.its.msstate.edu/e/bootstrap/'.$theme_custom_settings['assets']['e']['bootstrap'].'/js/bootstrap.min.js', array('type' => 'external', 'group' => JS_THEME, 'weight' => 991));
    drupal_add_js('//cdn01.its.msstate.edu/e/slick/'.$theme_custom_settings['assets']['e']['slick'].'/slick.min.js', array('type' => 'external', 'group' => JS_THEME, 'weight' => 992));

	drupal_add_js('//cdn01.its.msstate.edu/i/basedrupal/'.$theme_custom_settings['assets']['i']['base'].'/js/base.js', array('type' => 'external', 'group' => JS_THEME, 'weight' => 998));

	drupal_add_js(drupal_get_path('theme', $theme_custom_settings['theme_name']).'/js/app.js', array('group' => JS_THEME, 'weight' => 999));


	/**
	 *	Find template pages
	 *  
	 *  Add page template suggestions based on the aliased path. For instance, 
	 *  if the current page has an alias of about/history/early, we'll have templates of:
  	 *  page--about-history-early.tpl.php, page--about-history.tpl.php, page--about.tpl.php
	 *  inside hooks use underscores ("_") instead of hyphens ("-") when adding to the $vars[] but use hyphens for 
	 *  your template so page--about-history-early.tpl.php, page--about-history.tpl.php, and page--about.tpl.php
  	 *  Whichever is found first is the one that will be used.
  	 *   
	 *  https://drupal.org/node/223440
	 *  
	 *  Also, if using hyphens in aliased path, don't include them in your template name. For instance, if the current page has 
	 *  an alias of about-us/our-history/early-life, we'll have a template of: page--aboutus-ourhistory-earlylife.tpl.php
	 */
	if (module_exists('path')) 
	{
    	$alias = drupal_get_path_alias(str_replace('/edit','',$_GET['q']));

		$template_filename = '';
		
		// strip out '-' from path alias
		$alias = str_replace("-", "", $alias);
		
		$patterns = array();
		$patterns[0] = '/.php$/';
		$patterns[1] = '/.html$/';
		$patterns[2] = '/.htm$/';
		
		// break apart by folder path and look for template
		foreach (explode('/', $alias) as $path_part) 
		{
		    $template_filename .= '_' . $path_part;
		    $vars['theme_hook_suggestions'][] = 'html__' .preg_replace($patterns, '', ltrim($template_filename, '_'));
		}
		
		// print_r($vars['theme_hook_suggestions']);	
	}

}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Preprocess Page
 */

function basedrupal_preprocess_page(&$vars) 
{ 
	/**
	 *  Custom theme variables
	 */
	include 'theme_config.php';
	$vars['theme_custom_settings'] = $theme_custom_settings;


	/**
	 *	Find template pages
	 *  
	 *  Add page template suggestions based on the aliased path. For instance, 
	 *  if the current page has an alias of about/history/early, we'll have templates of:
  	 *  page--about-history-early.tpl.php, page--about-history.tpl.php, page--about.tpl.php
	 *  inside hooks use underscores ("_") instead of hyphens ("-") when adding to the $vars[] but use hyphens for 
	 *  your template so page--about-history-early.tpl.php, page--about-history.tpl.php, and page--about.tpl.php
  	 *  Whichever is found first is the one that will be used.
  	 *   
	 *  https://drupal.org/node/223440
	 *  
	 *  Also, if using hyphens in aliased path, don't include them in your template name. For instance, if the current page has 
	 *  an alias of about-us/our-history/early-life, we'll have a template of: page--aboutus-ourhistory-earlylife.tpl.php
	 */
	if (module_exists('path')) 
	{
    	$alias = drupal_get_path_alias(str_replace('/edit','',$_GET['q']));
		
		$template_filename = '';
		
		// strip out '-' from path alias
		$alias = str_replace("-", "", $alias);
		
		$patterns = array();
		$patterns[0] = '/.php$/';
		$patterns[1] = '/.html$/';
		$patterns[2] = '/.htm$/';
		
		// break apart by folder path and look for template
		foreach (explode('/', $alias) as $path_part) 
		{
		    $template_filename .= '_' . $path_part;
		    $vars['theme_hook_suggestions'][] = 'page__' .preg_replace($patterns, '', ltrim($template_filename, '_'));
		}
		
		// print_r($vars['theme_hook_suggestions']);	
	}
	
	
	
	// Get the entire main menu tree
	$main_menu_tree = menu_tree_all_data('main-menu');

	// Add the rendered output to the $main_menu_expanded variables
	// * check templates/inc/header.php for insertation
	$vars['main_menu_expanded'] = menu_tree_output($main_menu_tree);
  
    // Primary nav
	$vars['primary_nav'] = FALSE;
	$vars['primary_nav_mobile'] = FALSE;
	if ($vars['main_menu']) 
	{
    	// Build links
		$vars['primary_nav'] = menu_tree(variable_get('menu_main_links_source', 'main-menu'));
		$vars['primary_nav_mobile'] = menu_tree(variable_get('menu_main_links_source', 'main-menu'));
		// Provide default theme wrapper function
		$vars['primary_nav']['#theme_wrappers'] = array('menu_tree__primary');
		$vars['primary_nav_mobile']['#theme_wrappers'] = array('menu_tree__primary');
	}

	// Secondary nav
	$vars['secondary_nav'] = FALSE;
	if ($vars['secondary_menu']) 
	{
    	// Build links
		$vars['secondary_nav'] = menu_tree(variable_get('menu_secondary_links_source', 'user-menu'));
		// Provide default theme wrapper function
		$vars['secondary_nav']['#theme_wrappers'] = array('menu_tree__secondary');
	}

	// Replace tabs with drop down version
	$vars['tabs']['#primary'] = _bootstrap_local_tasks($vars['tabs']['#primary']);
  
	// Add variable for site title
	$vars['my_site_title'] = variable_get('site_name');
	
	// Get node fields in page.tpl
	// Added by awl22 (https://www.drupal.org/node/950434#comment-5090674)
	// Usage:
	// 		if (array_key_exists('field_name', $node_content)) 
	// 		{
    //			print render($node_content['field_name']);
	//		}
	if (arg(0) == 'node') 
	{
		$vars['node_content'] =& $vars['page']['content']['system_main']['nodes'][arg(1)];
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Preprocess block
 */

function basedrupal_preprocess_block(&$vars) 
{
	// Count number of blocks in a given theme region
	$vars['block_count'] = count(block_list($vars['block']->region));
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Determines if the region has at least one block for this user
 *
 * 	@param $region
 *  A string containing the region name
 *
 * 	@return
 *  TRUE if the region has at least one block. FALSE if it doesn't.
 */

function basedrupal_region_has_block($region) 
{
  	$number_of_blocks = count(block_list($region));

  	if ($number_of_blocks > 0) 
  	{
    	return TRUE;
	}
	else 
	{
		return FALSE;
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Determine the span for a block
 *
 * 	@param $block_count
 *  The number of blocks in the region
 *
 * 	@param $block_id
 *  The position of the block (starts at 1)
 *
 * 	@param $count_sidebars
 *  A boolean indicating whether sidebars should be counted
 *
 * 	@return
 *  The span value for the block at this location and region
 */

function basedrupal_get_span($block_count, $block_id, $count_sidebars) 
{
  	// @petechen (6.27.12) This method of applying a value to span assumes that there
  	// is at least 1 block. If there are no blocks, you end up with a calculation
  	// dividing by 0 generating a php error. Suggest the following change:
  
  	// default span if calculations fail
  	// Use this default value instead as an "else" condition below:
  	// $span = 12;

  	// there are 12 columsn in bootstrap
  	$available_width = 12;

  	if ($count_sidebars) 
  	{
	    // we assume that the left and right regions have a span of 3
	    // if present, we remove that much from the available width
		if (basedrupal_region_has_block('sidebar_first')) 
		{
			$available_width = $available_width - 0;
		}

		if (basedrupal_region_has_block('sidebar_second')) 
		{
			$available_width = $available_width - 0;
		}
	}

	// @petechen - surroung this condition with another if else to account for $block_count = 0
  
	if ($block_count != 0) 
	{
		// if the number of blocks divides evenly into the available width, that's our span width
		if (($available_width % $block_count) == 0) 
		{
			$span = $available_width / $block_count;
		}
		// if the number of blocks does not divide evenly, we look up the span widths in an array
		// where then indexes are available width, number of blocks, and block position
		// e.g. [9][2][1] is the span of the first block, out of two when the available width is 9.
		else 
		{
		    $exceptions[6][4][1] = 2;
		    $exceptions[6][4][2] = 2;
		    $exceptions[6][4][3] = 1;
		    $exceptions[6][4][4] = 1;
		
		    $exceptions[6][5][1] = 1;
		    $exceptions[6][5][2] = 1;
		    $exceptions[6][5][3] = 1;
		    $exceptions[6][5][4] = 1;
		    $exceptions[6][5][5] = 1;
		
		    $exceptions[9][2][1] = 3;
		    $exceptions[9][2][2] = 6;
		
		    $exceptions[9][4][1] = 3;
		    $exceptions[9][4][2] = 2;
		    $exceptions[9][4][3] = 2;
		    $exceptions[9][4][4] = 2;
		
		    $exceptions[9][5][1] = 3;
		    $exceptions[9][5][2] = 1;
		    $exceptions[9][5][3] = 1;
		    $exceptions[9][5][4] = 1;
		    $exceptions[9][5][5] = 3;
		
		    $exceptions[9][6][1] = 2;
		    $exceptions[9][6][2] = 2;
		    $exceptions[9][6][3] = 2;
		    $exceptions[9][6][4] = 1;
		    $exceptions[9][6][5] = 1;
		    $exceptions[9][6][6] = 1;
		
		    $exceptions[12][5][1] = 3;
		    $exceptions[12][5][2] = 2;
		    $exceptions[12][5][3] = 2;
		    $exceptions[12][5][4] = 2;
		    $exceptions[12][5][5] = 3;

			$span = $exceptions[$available_width][$block_count][$block_id];
		}

		return $span;
	}
	// @petechen: so if $block_count = 0, use this as the default
	else $span = 12;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Returns HTML for status and/or error messages, grouped by type.
 */
 
function basedrupal_status_messages($variables) 
{
	$display = $variables['display'];
	$output = '';
	
	$status_heading = array(
	  	'status' 	=> t('Status message'),
	  	'error' 	=> t('Error message'),
	  	'warning' 	=> t('Warning message'),
	);
	
	// Map Drupal message types to their corresponding Bootstrap classes.
	// @see http://twitter.github.com/bootstrap/components.html#alerts
	$status_class = array(
	  	'status' 	=> 'success',
	  	'error' 	=> 'danger',
	  	'warning' 	=> 'warning',
	);
	
	foreach (drupal_get_messages($display) as $type => $messages) 
	{
	  	$class = (isset($status_class[$type])) ? ' alert-' . $status_class[$type] : '';
	  	$output .= "<div class=\"alert alert-$class\">\n";
	  
	  	if (arg(0) != 'admin' && arg(0) != 'panels' && arg(0) != 'ctools') 
	  	{
		  	//$output .= "  <a class=\"close\" data-dismiss=\"alert\" href=\"#\">x</a>\n";
		  	$output .= "  <button type=\"button\" class=\"close\" data-dismiss=\"alert\">&times;</button>\n";
		}
	  
		if (!empty($status_heading[$type])) 
		{
			$output .= '<h2 class="element-invisible">' . $status_heading[$type] . "</h2>\n";
		}
	
		if (count($messages) > 1) 
		{
	    	$output .= " <ul>\n";
			foreach ($messages as $message) 
			{
				$output .= '  <li>' . $message . "</li>\n";
			}
			$output .= " </ul>\n";
		}
		else 
		{
	    	$output .= $messages[0];
		}
	
		$output .= "</div>\n";
	}

	return $output;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Alter Various Forms
 */

function search_preprocess_block(&$variables) 
{
	if ($variables['block']->module == 'search') 
	{
    	$variables['attributes_array']['role'] = 'search';
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Alter forms
 */

function basedrupal_form_alter(&$form, &$form_state, $form_id) 
{
	/**
	 * 	Alter user_login form
	 * 	
	 * 	remove user registration and request new password from user account login page since using CAS
	 */
  	if ($form_id == 'user_login')
  	{
		$form['actions']['submit']['#attributes']['class'][] = 'btn';
		$form['actions']['submit']['#attributes']['class'][] = 'btn-large';
	}

	/**
	 * Alter views_exposed_form to use bootstrap
	 */
  	if ($form_id == 'views_exposed_form')
  	{
	  	// each field
	  	foreach ($form['#info'] as $key => $value)
	  	{
		  	$element = $form['#info'][$key]['value'];
		  	$label = $form['#info'][$key]['label'];
		  	
		  	if (isset($form[$element]['#type']) && ($form[$element]['#type'] == 'select'))
		  	{
				$form[$element]['#attributes']['class'][] = 'form-control';
				$form[$element]['#options']['All'] = $label.' (All)';
			}
	  	}
	  	
	  	// submit button
		$form['submit']['#attributes']['class'][] = 'btn';
		$form['submit']['#attributes']['class'][] = 'btn-default';
		
		// form
		$form['#attributes']['class'][] = 'form-inline';
		
		//echo '<pre>'; print_r($form); echo '</pre>';
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/** 
 * 	Returns HTML for primary and secondary local tasks. 
 */

function basedrupal_menu_local_tasks(&$vars) 
{
  	$output = '';

  	if ( !empty($vars['primary']) ) 
  	{
    	$vars['primary']['#prefix'] = '<h2 class="element-invisible">' . t('Primary tabs') . '</h2>';
		$vars['primary']['#prefix'] = '<ul class="nav nav-tabs">';
		$vars['primary']['#suffix'] = '</ul>';
		$output .= drupal_render($vars['primary']);
	}

	if ( !empty($vars['secondary']) ) 
	{
    	$vars['primary']['#prefix'] = '<h2 class="element-invisible">' . t('Primary tabs') . '</h2>';
		$vars['secondary']['#prefix'] = '<ul class="nav nav-pills">';
		$vars['secondary']['#suffix'] = '</ul>';
		$output .= drupal_render($vars['secondary']);
	}

	return $output;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	Returns HTML for primary and secondary local task.
 */

function basedrupal_menu_local_task($vars) 
{
  	$link = $vars['element']['#link'];
  	$link_text = $link['title'];
  	$classes = array();

  	if (!empty($vars['element']['#active'])) 
  	{
    	// Add text to indicate active tab for non-visual users.
		$active = '<span class="element-invisible">' . t('(active tab)') . '</span>';

		// If the link does not contain HTML already, check_plain() it now.
		// After we set 'html'=TRUE the link will not be sanitized by l().
		if (empty($link['localized_options']['html'])) 
		{
			$link['title'] = check_plain($link['title']);
		}

		$link['localized_options']['html'] = TRUE;
		$link_text = t('!local-task-title!active', array('!local-task-title' => $link['title'], '!active' => $active));

		$classes[] = 'active';
	}

	return '<li class="' . implode(' ', $classes) . '">' . l($link_text, $link['href'], $link['localized_options']) . "</li>\n";
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * Alter menu tree to include bootstrap wrapper
 */
function basedrupal_menu_tree(&$vars) 
{
	/* change parent ul menu classes if menu is pulled from the main-menu for page submenus */
	if(stripos($vars['tree'], 'menu-mlid') !== false)
		return '<ul class="menu nav">' . $vars['tree'] . '</ul>';
	else	
		return '<ul class="menu nav navbar-nav">' . $vars['tree'] . '</ul>';
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Implements hook_menu_link
 *  Apply bootstrap menu classes to all menu blocks in the 
 *  navigation region and the main-menu block by default.
 *  Note: if a menu is in the navigation and somewhere else as well,
 *       both instances of the menu will have the classes applied,
 *       not just the one in the navigation
 */

function basedrupal_menu_link(array $vars) 
{
	
  	$element = $vars['element'];

  	if (basedrupal_is_in_nav_menu($element)) 
  	{
    	$sub_menu = '';

		if ($element['#below']) 
		{
			// Add our own wrapper
			unset($element['#below']['#theme_wrappers']);
	  
			if($element['#theme'] == 'menu_link__main_menu')
			{
				$sub_menu = '<ul class="dropdown-menu">' . drupal_render($element['#below']) . '</ul>';
				$element['#localized_options']['attributes']['class'][] = 'dropdown-toggle';
				$element['#localized_options']['attributes']['data-toggle'] = 'dropdown';

				// Check if this element is nested within another
				if ((!empty($element['#original_link']['depth'])) && ($element['#original_link']['depth'] > 1)) 
				{
					// Generate as dropdown submenu
					$element['#attributes']['class'][] = 'dropdown-submenu';
				}
				else 
				{
					// Generate as standard dropdown
					$element['#attributes']['class'][] = 'dropdown';
					$element['#localized_options']['html'] = TRUE;
					$element['#title'] .= ' <span class="caret"></span>';
				}

				// Set dropdown trigger element to # to prevent inadvertant page loading with submenu click
				$element['#localized_options']['attributes']['data-target'] = '#';
			}
			else
			{
				/* ******* */
				/* FORKED from above qtc1 */
				/* this generates clean submenus (aka without dropdown shit) for in page content side menu */
				
				$sub_menu = '<ul class="menu nav">' . drupal_render($element['#below']) . '</ul>';
				//$element['#localized_options']['attributes']['class'][] = 'dropdown-toggle';
				//$element['#localized_options']['attributes']['data-toggle'] = 'dropdown';

				// Check if this element is nested within another
				if ((!empty($element['#original_link']['depth'])) && ($element['#original_link']['depth'] > 1)) 
				{
					// Generate as dropdown submenu
					//$element['#attributes']['class'][] = 'dropdown-submenu';
				}
				else 
				{
					// Generate as standard dropdown
					$element['#attributes']['class'][] = 'dropdown';
					$element['#localized_options']['html'] = TRUE;
					$element['#title'] .= ' <span class="caret"></span>';
				}

				// Set dropdown trigger element to # to prevent inadvertant page loading with submenu click
				//$element['#localized_options']['attributes']['data-target'] = '#';
			}
		}
    
		$output = l($element['#title'], $element['#href'], $element['#localized_options']);
    
		// if link class is active, make li class as active too
		if(strpos($output,"active") > 0)
		{
        	$element['#attributes']['class'][] = "active";
		}
    
		return '<li' . drupal_attributes($element['#attributes']) . '>' . $output . $sub_menu . "</li>\n";

	} 
	else 
	{
    	$element = $vars['element'];
		$sub_menu = '';

		if ($element['#below']) 
		{
			$sub_menu = drupal_render($element['#below']);
		}

		$output = l($element['#title'], $element['#href'], $element['#localized_options']);
    
		// if link class is active, make li class as active too
		if(strpos($output,"active") > 0)
		{
        	$element['#attributes']['class'][] = "active";
		}
    
		return '<li' . drupal_attributes($element['#attributes']) . '>' . $output . $sub_menu . "</li>\n";
	}
}






/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Get all primary tasks including subsets
 */
 
function _bootstrap_local_tasks($tabs = FALSE) 
{
  	if ($tabs == '') 
  	{
    	return $tabs;
	}
  
	if (!$tabs) 
	{
    	$tabs = menu_primary_local_tasks();
	}
  
	foreach ($tabs as $key => $element) 
	{
    	$result = db_select('menu_router', NULL, array('fetch' => PDO::FETCH_ASSOC))
			->fields('menu_router')
			->condition('tab_parent', $element['#link']['path'])
			->condition('context', MENU_CONTEXT_INLINE, '<>')
			->condition('type', array(MENU_DEFAULT_LOCAL_TASK, MENU_LOCAL_TASK), 'IN')
			->orderBy('weight')
			->orderBy('title')
			->execute();
  
		$router_item = menu_get_item($element['#link']['href']);
		$map = $router_item['original_map'];
  
		$i = 0;
		foreach ($result as $item) 
		{
			_menu_translate($item, $map, TRUE);
  
			//only add items that we have access to
			if ($item['tab_parent'] && $item['access']) 
			{
				//set path to that of parent for the first item
				if ($i === 0) 
				{
					$item['href'] = $element['#link']['href'];
				}
  
				if (current_path() == $item['href']) 
				{
					$tabs[$key][] = array(
					'#theme' => 'menu_local_task',
					'#link' => $item,
					'#active' => TRUE,
					);
				}
				else 
				{
					$tabs[$key][] = array(
					'#theme' => 'menu_local_task',
					'#link' => $item,
					);
				}
  
				//only count items we have access to.
				$i++;
			}
		}
	}
  
	return $tabs;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 * 	hook_item_list
 */

function basedrupal_item_list($variables) 
{
  	$items = $variables['items'];
  	$title = $variables['title'];
  	$type = $variables['type'];
  	$attributes = $variables['attributes'];
  	$output = '';

  	if (isset($title)) 
  	{
   		$output .= '<h3>' . $title . '</h3>';
   	}

   	if (!empty($items)) 
   	{
    	$output .= "<$type" . drupal_attributes($attributes) . '>';
		$num_items = count($items);

		foreach ($items as $i => $item) 
		{
			$attributes = array();
			$children = array();
			$data = '';
			if (is_array($item)) 
			{
				foreach ($item as $key => $value) 
				{
					if ($key == 'data') {
						$data = $value;
					}
					elseif ($key == 'children') 
					{
						$children = $value;
					}
					else 
					{
						$attributes[$key] = $value;
					}
				}
			}
			else
			{
				$data = $item;
			}

			if (count($children) > 0) 
			{
				// Render nested list.
				$data .= theme_item_list(array('items' => $children, 'title' => NULL, 'type' => $type, 'attributes' => $attributes));
			}

			if ($i == 0) 
			{
				$attributes['class'][] = 'first';
			}

			if ($i == $num_items - 1) {
				$attributes['class'][] = 'last';
			}

			$output .= '<li' . drupal_attributes($attributes) . '>' . $data . "</li>\n";
		}

		$output .= "</$type>";
	}
 
	return $output;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Find out if an element (a menu link) is a link displayed in the
 *  navigation region for the user. We return true by default if this is a 
 *  menu link in the main-menu. Open Framework treats the main-menu
 *  as being in the navigation by default.
 *  We are using the theming functions to figure out the block IDs.
 *  The block IDs aren't passed to this function, but theming function names are,
 *  and those are baed on the block ID.
 */

function basedrupal_is_in_nav_menu($element) 
{

	// #theme holds one or more suggestions for theming function names for the link
	// simplify things by casting into an array
	$link_theming_functions = (array)$element['#theme'];
	
	// Avoid calculating this more than once
	$nav_theming_functions = &drupal_static(__FUNCTION__);
	
	// if not done yet, calculate the names of the theming function for all the blocks
	// in the navigation region
	
	if (!isset($nav_theming_functions)) 
	{
	  	// get all blocks in the navigation region
	  	$blocks = block_list('navigation');
	
	  	// Blocks placed using the context module don't show up using Drupal's block_list
	  	// If context is enabled, see if it has placed any blocks in the navigation area
	  	// See: http://drupal.org/node/785350
	  	$context_blocks = array();
	  
	  	if (module_exists('context')) {
	    	$reaction_block_plugin = context_get_plugin('reaction', 'block');
			$context_blocks = $reaction_block_plugin->block_list('navigation');
		}
	
		$blocks = array_merge($blocks, $context_blocks);
	
		// extract just their IDs (<module>_<delta>)
		$ids = array_keys($blocks);
	
		// translate the ids into function names for comparison purposes
		$nav_theming_functions = array_map('basedrupal_block_id_to_function_name', $ids);
	}
	
	// if there is nothing in the navigation section, the main menu is added automatically, so
	// we watch for that.
	// 'menu_link__main_menu' is the theming function name for the main-menu
	if ((empty($nav_theming_functions)) && (in_array('menu_link__main_menu', $link_theming_functions))) {
	  	return TRUE;
	};
	
	// Find out if any of the theming functions for the blocks are the same
	// as the theming functions for the link.
	$intersect = array_intersect($nav_theming_functions, $link_theming_functions);
	if ((!empty($intersect))) 
	{
	  	return TRUE;
	}
	else 
	{
	  	return FALSE;
	}
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Convert a block id to a theming function name
 */

function basedrupal_block_id_to_function_name($id) 
{
  	// if a system block, remove 'system_'
  	$id = str_replace('system_', '', $id);

  	// recognize menu and block_menu module blocks
  	if (strpos($id, 'menu_block_') === false) 
  	{
    	// if a menu block but not a menu_block block, remove menu_
		$id = str_replace('menu_',       '', $id);
	}
	else 
	{
    	// if a menu_block block, keep menu_block, but add an
		// underscore. Not sure why this is different from other
		// core modules
		$id = str_replace('menu_block_', 'menu_block__', $id);
	} 

	// massage the id to looks like a theming function name
	// use the same function used to create the name of theming function
	$id = strtr($id, '-', '_');
	$name = 'menu_link__' . $id;

	return $name;
}





/** ------------------------------------------------------------------------------------------------------- */
/**
 *  Alter breadcrumb to bootstrap formating and add page title at the end
 */

function basedrupal_breadcrumb($variables) 
{
	$breadcrumb = $variables['breadcrumb'];
	
	// Check if breadcrumb and reformat.
	if ( ! empty($breadcrumb)) 
	{
		//echo '<pre>'; print_r($breadcrumb); echo '</pre>';
		
		$crumbs = '<ol class="breadcrumb">';
		
        $array_size = count($breadcrumb);
        $i = 0;
        
        while ($i < $array_size) 
        {
			$crumbs .= '<li class="breadcrumb-' . $i;

			if ($i == 0) {
				$crumbs .= ' first';
			}

          	/* 
          	if ($i+1 == $array_size) {
            	$crumbs .= ' last';
          	} 
          	*/
          
		  	$crumbs .=  '">' . $breadcrumb[$i] . '</li>';

		  	$i++;
        }
        
        $crumbs .= '<li class="active">'. drupal_get_title() .'</li></ol>';
        
        return $crumbs;
	}
}
